--[
import Prelude hiding (fst, snd)

data Nat = Z | S Nat deriving Show
data Unit = Unit
data Pair a b = Pair a b deriving Show

data Stream a = Cons a (Stream a) deriving Show
data Tree a = Leaf | Node a (Tree a) (Tree a) deriving Show
--]

-- --lazy fst
-- --lazy snd
fst (Pair a b) = a;
snd (Pair a b) = b;

--lazy lab
--[
lab :: Tree a -> Stream (Stream b) -> Pair (Tree b) (Stream (Stream b))
--]
lab  Leaf         bss             = Pair Leaf bss;
lab (Node x l r) (Cons (Cons b bs) bss) =
  let    pl = lab l bss
  in let pr = lab r (snd pl)
  in Pair (Node b (fst pl) (fst pr))
          (Cons bs (snd pr));

--lazy label2
--[
label2 :: Tree a -> Stream b -> Stream (Stream b)
--]
label2 t bs = snd (lab t (Cons bs (label2 t bs)));

--[
label :: Tree a -> Stream b -> Tree b
--]
label t bs = fst (lab t (Cons bs (label2 t bs)));

--lazy nats
--[
nats :: Nat -> Stream Nat
--]
nats n = Cons n (nats (S n));

--[
finTree :: Nat -> Tree Unit
--]
finTree Z     = Leaf;
finTree (S n) = Node Unit (finTree n) (finTree n);

--[
t :: Nat -> Tree Nat
--]
t n = label (finTree n) (nats Z);

t0 = t Z;
t1 = t (S Z);
t2 = t (S (S Z));
t3 = t (S (S (S Z)));
