sized data Nat : Size -> Set 
{ zero : (i : Size) -> Nat ($ i)
; suc  : (i : Size) -> Nat i -> Nat ($ i)
}

let one : Nat # = suc # (zero #)

fun add : Nat # -> Nat # -> Nat #
{ add (zero .#)  m = m
; add (suc .# n) m = suc # (add n m)
}

fun mul : Nat # -> Nat # -> Nat #
{ mul (zero .#)  m = zero #
; mul (suc .# n) m = add m (mul n m)
} 

data List (+A : Set) : Set
{ nil  : List A
; cons : A -> List A -> List A
}

fun ids : [A : Set] -> (n : Nat #) -> List (A -> A)
{ ids A (zero .#)  = nil (A -> A)
; ids A (suc .# n) = cons (A -> A) (\ x -> x) (ids A n)
}

fun comp : [A : Set] -> List (A -> A) -> (A -> A)  
{ comp A (nil .(A -> A))       a = a
; comp A (cons .(A -> A) f fs) a = f (comp A fs a)
}

fun fact : (i : Size) -> (n : Nat i) -> Nat #
{ fact .($ i) (zero i)  = one
; fact .($ i) (suc i n) = mul n (fact i (comp (Nat i) (ids (Nat i) n) n))
}